* ------------------------------------------------------------------------
* ------------------------------------------------------------------------
* SISTEMA.......:
* PROGRAMA......:
* AUTOR.........: EDUARDO V. FLORES RIVAS
* FECHA.........:
* ACTUALIZADO...:
* COMENTARIOS...:
* ------------------------------------------------------------------------
* ------------------------------------------------------------------------

PROC ComparaDBFS

   DEFINE WINDOW Win_DBFMatch ;
      AT 0,0 ;
      WIDTH 1000 ;
      HEIGHT 700 ;
      TITLE 'Comparar dbfs'  ;
      MODAL ;
      ON INIT DBFMatchInicia() ;
      FONT 'ARIAL' SIZE 9
//
//
//
      DEFINE TOOLBAR DBFMatchBarra BUTTONSIZE 70,30 FLAT BORDER

         BUTTON BotCargar ;
            CAPTION '&Cargar' ;
            PICTURE 'imagen\engranajes.bmp' ;
            ACTION DBFMatchCargar()

         BUTTON BotSalir     ;
            CAPTION '&Salir'   ;
            PICTURE 'imagen\salir.bmp' ;
            ACTION DBFMatchSalir()

      END TOOLBAR
//
//
//
      @ 060 , 020 LABEL Label_1 ;
        VALUE 'Folder 1:' ;
        ACTION DBFMatchSet1() ;
        WIDTH 90 ;
        FONTCOLOR Color_Label4_Font ;
        BACKCOLOR Color_Label4_Back ;
        RIGHTALIGN

      @ 060 , 120 TEXTBOX Folder1 ;
        WIDTH 700 ;
        READONLY
//
//
//
      @ 090 , 020 LABEL Label_2 ;
        VALUE 'Folder 2:' ;
        ACTION DBFMatchSet2() ;
        WIDTH 90 ;
        FONTCOLOR Color_Label4_Font ;
        BACKCOLOR Color_Label4_Back ;
        RIGHTALIGN

      @ 090 , 120 TEXTBOX Folder2 ;
        WIDTH 700 ;
        READONLY
//
//
//
      @ 130 , 010 BROWSE BrwDBFMatch ;
        WIDTH  980 ;
        HEIGHT 510 ;
        HEADERS { 'Archivo 1', 'Campo 1'  , 'Tipo 1'  , 'Long.1' , 'Decim.1' , 'Archivo 2', 'Campo 2'  , 'Tipo 2'  , 'Long. 2' , 'Decim.2' } ;
        FIELDS  { 'ARCHIVO1' , 'CAMPO1'   , 'TIPO1'   , 'LONG1'  , 'DECI1'   , 'ARCHIVO2' , 'CAMPO2'   , 'TIPO2'   , 'LONG2'   , 'DECI2'   } ;
        WIDTHS  {   200      ,   080      ,  080      ,   050    ,  050      ,   200      ,   080      ,  080      ,   060     ,  050      } ;
        JUSTIFY {   BrwL     ,  BrwL      ,  BrwC     ,   BrwR   ,  BrwR     ,   BrwL     ,  BrwL      ,  BrwC     ,   BrwR    ,  BrwR     } ;
        WORKAREA XVS

   END WINDOW

   CENTER WINDOW Win_DBFMatch
   ACTIVATE WINDOW Win_DBFMatch

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC DBFMatchInicia()


RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC DBFMatchSalir()

   Win_DBFMatch.Release

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC DBFMatchSet1()

LOCAL cActualPath := GetCurrentFolder()
LOCAL cFold1      := GetFolder()

   SetCurrentFolder( cActualPath )

   IF EMPTY( cFold1 )
      RETURN
   ENDIF

   Win_DBFMatch.Folder1.Value := cFold1

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC DBFMatchSet2()

LOCAL cActualPath := GetCurrentFolder()
LOCAL cFold2      := GetFolder()

   SetCurrentFolder( cActualPath )

   IF EMPTY( cFold2 )
      RETURN
   ENDIF

   Win_DBFMatch.Folder2.Value := cFold2

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC DBFMatchCargar()

LOCAL cDBFMatchDbf := GetDesktopFolder()+'\DBFMatch.dbf'
LOCAL cDBFMatchCdx := GetDesktopFolder()+'\DBFMatch.cdx'
LOCAL aDBFMatchDbf := {;
{'ARCHIVO1','C',30,0},;
{'CAMPO1'  ,'C',10,0},;
{'TIPO1'   ,'C', 1,0},;
{'LONG1'   ,'N', 6,0},;
{'DECI1'   ,'N', 6,0},;
{'VS'      ,'C', 1,0},;
{'ARCHIVO2','C',30,0},;
{'CAMPO2'  ,'C',10,0},;
{'TIPO2'   ,'C', 1,0},;
{'LONG2'   ,'N', 6,0},;
{'DECI2'   ,'N', 6,0}}

   IF EMPTY(Win_DBFMatch.Folder1.Value) .OR. EMPTY(Win_DBFMatch.Folder2.Value)
      RETURN
   ENDIF

   Win_DBFMatch.DBFMatchBarra.Enabled := .F.

   DELETE FILE &cDBFMatchCdx
   DBCREATE( cDBFMatchDbf , aDBFMatchDbf )

   SELE 0
   USE &cDBFMatchDbf ALIAS XVS EXCLUSIVE VIA 'DBFCDX'
   INDEX ON ARCHIVO1 TAG XVSxFile TO &cDBFMatchCdx
   SET INDEX TO &cDBFMatchCdx

   cFoldOrigen := ALLTRIM(Win_DBFMatch.Folder1.Value)
   cFoldDestin := ALLTRIM(Win_DBFMatch.Folder2.Value)
   aDir1 := DIRECTORY( cFoldOrigen+'\*.dbf' )
   FOR nDir1 = 1 TO LEN(aDir1)
      DBFMatchComparar( cFoldOrigen , cFoldDestin , aDir1[nDir1,1] )
   NEXT

   DBGOTOP()
   Win_DBFMatch.BrwDBFMatch.Value := XVS->(RECNO())
   Win_DBFMatch.BrwDBFMatch.Refresh
   Win_DBFMatch.BrwDBFMatch.Setfocus

   Win_DBFMatch.DBFMatchBarra.Enabled := .T.

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC DBFMatchComparar
PARA cQueOrigen,cQueDestin,cQueFile

   IF ! FILE(cQueDestin+'\'+cQueFile)
      APPEND BLANK
      XVS->ARCHIVO1 := cQueFile
      XVS->ARCHIVO2 := 'NO EXISTE'
      RETURN
   ENDIF

   SELE 0
   USE (cQueOrigen+'\'+cQueFile) ALIAS VS1 SHARED
   aVS1 := DBSTRUCT()

   SELE 0
   USE (cQueDestin+'\'+cQueFile) ALIAS VS2 SHARED
   aVS2 := DBSTRUCT()

   CLOSE VS1
   CLOSE VS2
   SELECT XVS

   FOR nVS1 = 1 TO LEN(aVS1)
      nVS2 := ASCANMULTI( aVS2 , aVS1[nVS1,1] , 1 )
      IF nVS2 > 0
         IF aVS2[nVS2,2] <> aVS1[nVS1,2] .OR. aVS2[nVS2,3] <> aVS1[nVS1,3] .OR. aVS2[nVS2,4] <> aVS1[nVS1,4]
            APPEND BLANK
            XVS->ARCHIVO1 := cQueFile
            XVS->CAMPO1   := aVS1[nVS1,1]
            XVS->TIPO1    := aVS1[nVS1,2]
            XVS->LONG1    := aVS1[nVS1,3]
            XVS->DECI1    := aVS1[nVS1,4]
            XVS->ARCHIVO2 := cQueFile
            XVS->CAMPO2   := aVS2[nVS2,1]
            XVS->TIPO2    := aVS2[nVS2,2]
            XVS->LONG2    := aVS2[nVS2,3]
            XVS->DECI2    := aVS2[nVS2,4]
         ENDIF
      ELSE
         APPEND BLANK
         XVS->ARCHIVO1 := cQueFile
         XVS->CAMPO1   := aVS1[nVS1,1]
         XVS->TIPO1    := aVS1[nVS1,2]
         XVS->LONG1    := aVS1[nVS1,3]
         XVS->DECI1    := aVS1[nVS1,4]
         XVS->ARCHIVO2 := cQueFile
         XVS->CAMPO2   := 'NO CAMPO'
      ENDIF
   NEXT

RETURN