*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* SISTEMA......:
* PROGRAMA.....: FUNCION.PRG
* AUTOR........: EDUARDO V. FLORES RIVAS
* FECHA........: 19-04-94
* ACTUALIZADO..: 23-05-95
* COMENTARIOS..: LIBRERIA DE FUNCIONES GENERALES.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : LENNOSPC
* COMENTARIO: Devolver la longitud de una cadena sin espacios
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC LENNOSPC(Objeto)

LOCAL Longitud:=0

DO CASE
   CASE VALTYPE(Objeto)='C'
      Longitud:=LEN(ALLTRIM(Objeto))
   CASE VALTYPE(Objeto)='N'
      IF Objeto>0
         Longitud:=LENNUM(Objeto)
      ENDIF
ENDCASE

RETURN(Longitud)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : FECHAR
* COMENTARIO: TRANSFORMAR UNA FECHA (dd/mm/aa) a formato completo
*             EJEM: Fechar('19940505') = Jueves 5 de Mayo de 1994 (05/05/94)
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC FECHAR(Fecha)

LOCAL MesNom:={ 'Enero','Febrero','Marzo','Abril','Mayo','Junio','Julio',;
                'Agosto','Setiembre','Octubre','Noviembre','Diciembre'}
LOCAL DiaNom:={'Domingo','Lunes','Martes','Miercoles','Jueves','Viernes','Sbado'}
LOCAL UniYea
LOCAL LINE_FECHA

IF VALTYPE(Fecha)<>'D'
   IF VALTYPE(Fecha)='C'
      IF '/' $ Fecha
         Fecha:=CTOD(Fecha)
      ELSE
         Fecha:=STOD(Fecha)
      ENDIF
   ELSE
      RETURN(REPL(15,'?'))
   ENDIF
ENDIF
UniYea:=IF(YEAR(Fecha)>1999,' del ',' de ')
LINE_FECHA:=DiaNom[DOW(Fecha)]+' '+ALLTRIM(STR(DAY(Fecha)))+' de '+MesNom[MONTH(Fecha)]+UniYea+STR(YEAR(Fecha),4)

RETURN(LINE_FECHA)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : CMES
* COMENTARIO: RETORNA EL MES DE LA FECHA EN ESPAOL
*             EJEM: Noviembre
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC CMES(Fecha,Grande)

LOCAL MesNom:={ 'Enero','Febrero','Marzo','Abril','Mayo','Junio','Julio',;
                'Agosto','Setiembre','Octubre','Noviembre','Diciembre'}
LOCAL MesLine

DO CASE
   CASE VALTYPE(Fecha)='N'
      MesLin:=MesNom[Fecha]
   CASE VALTYPE(Fecha)='D'
      MesLin:=MesNom[MONTH(Fecha)]
   CASE VALTYPE(Fecha)='C'
      Fecha:=CTOD(Fecha)
      MesLin:=MesNom[MONTH(Fecha)]
ENDCASE
MesLin:=IF(Grande<>NIL,UPPER(MesLin),MesLin)

RETURN(MesLin)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : CDIA
* COMENTARIO: RETORNA EL DIA DE LA FECHA EN ESPAOL
*             EJEM: Domingo
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC CDIA(Fecha)

LOCAL DiaNom:={'Domingo','Lunes','Martes','Miercoles','Jueves','Viernes','Sbado'}
LOCAL DiaLin

IF VALTYPE(Fecha)='C'
   Fecha:=CTOD(Fecha)
ENDIF
DiaLin:=DiaNom[DOW(Fecha)]

RETURN(DiaLin)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : STOD
* COMENTARIO: Convertir fecha formato STRING a formato DATE
*             Esta funcin es la contraria a DTOS(fecha).
*             Ejem:
*             STOD('19943101') --> 31/01/1994 (Formato DATE)
*             Nota: String debe ser una cadena de fecha vlida.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC STOD(String)

LOCAL AS:=SUBSTR(String,3,2)
LOCAL MS:=SUBSTR(String,5,2)
LOCAL DS:=RIGHT(String,2)
LOCAL DChar:=DS+'/'+MS+'/'+AS
DChar:=CTOD(DChar)

RETURN(DChar)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : STOC
* COMENTARIO: Convertir fecha en formato STRING a formato fecha CHARACTER
*            Esta funcin es la contraria a DTOS(fecha)
*            Ejem: STOC('19943101') convierte a '31/01/1994'
*                                 (Formato CHARACTER)
*               STOC('19943101',2) convierte a '31/01/94'
*                                 (Formato CHARACTER)
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC STOC(String,KAnual)

LOCAL AS , MS , DS , DChar

IF AT('/',String) = 0
   String := LEFT( String , 8 )
   AS     := IF(KAnual=NIL,SUBSTR(String,3,2),LEFT(String,4))
   MS     := SUBSTR(String,5,2)
   DS     := RIGHT(String,2)
   DChar  := DS+'/'+MS+'/'+AS
ELSE
   DChar := String
ENDIF

RETURN(DChar)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : CTOS
* COMENTARIO: Convertir fecha de formato CHARACTER a formato STRING.
*             Esta funcin es la contraria a STOC(fecha)
*             Ejem: CTOS('31/12/94') convierte a '19941231'
*
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC CTOS(String)

LOCAL Dchar:=DTOS(CTOD(String))

RETURN(DChar)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : DTOC4
* COMENTARIO: Convertir fecha de formato DATE a formato CHARACTER con
*             4 digitos para el ao.
*
*             Ejem: DTOC4(HOY) convierte a '31/12/2005'
*
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC DTOC4(dFecha)

LOCAL sFecha:=DTOS(dFecha)
LOCAL cFecha:=RIGHT(sFecha,2)+'/'+SUBSTR(sFecha,5,2)+'/'+LEFT(sFecha,4)

RETURN(cFecha)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : DTOC6
* COMENTARIO: Convertir fecha de formato DATE a formato STRING
*
*             Ejem: DTOC6(HOY) convierte a '201206'
*
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC DTOS6(dFecha)

LOCAL sFecha:=DTOS(dFecha)
LOCAL cFecha:=LEFT(sFecha,6)

RETURN(cFecha)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : CTOC
* COMENTARIO: Verifica si una fecha ingresada mediante un GET del tipo
*             GET fecha PICT '@D' o una fecha CHARACTER = '31/12/96'
*             es vlida.
*             Si no es vlida y el parametro <ajuste> es 1 bscara la fecha
*             posterior ms prxima.  Si <ajuste> es 0 buscar la fecha
*             anterior ms prxima.
* RESULTADO : La funcin devuelve una fecha vlida en formato CHARACTER
*             Ejem:  CTOC('32/12/96',0) => '31/12/96'
*                    CTOC('32/12/96',1) => '01/01/97'
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC CTOC(Fecha,Ajuste)

LOCAL DFec
LOCAL MFec
LOCAL AFec

Ajuste:=IF(Ajuste=NIL,0,Ajuste)
IF DTOS(CTOD(Fecha))=SPACE(8)
   DFec:=VAL(LEFT(Fecha,2))
   MFec:=VAL(SUBSTR(Fecha,4,2))
   AFec:=VAL(RIGHT(Fecha,2))
   MFec:=IF(MFec>12,12,MFec)
   MFec:=IF(MFec<1,1,MFec)
   DFec:=IF(DFec>31,31,DFec)
   DFec:=IF(DFec<1,1,DFec)
   Fecha:=STRZERO(DFec,2)+'/'+STRZERO(MFec,2)+'/'+STRZERO(AFec,2)
   DO CASE
      CASE Ajuste=0
         DO WHILE DTOS(CTOD(Fecha))=SPACE(8)
            DFec--
            Fecha:=STRZERO(DFec,2)+'/'+STRZERO(MFec,2)+'/'+STRZERO(AFec,2)
         ENDDO
      CASE Ajuste=1
         DO WHILE DTOS(CTOD(Fecha))=SPACE(8)
            DFec:=1
            MFec++
            Fecha:=STRZERO(DFec,2)+'/'+STRZERO(MFec,2)+'/'+STRZERO(AFec,2)
         ENDDO
    ENDCASE
ENDIF

RETURN(Fecha)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : FTOV
* COMENTARIO: Convertir fecha de formato CHARACTER  DATE a un VALOR.
*             Ejem: fechav=FTOV('31/12/94')
*                   fechav=19941231
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC FTOV(FechaX)

LOCAL FechaV

DO CASE
   CASE VALTYPE(FechaX)='C'
      IF AT('/',FechaX) > 0
         FechaV := VAL(CTOS(FechaX))
      ELSE
         FechaV := VAL(FechaX)
      ENDIF
   CASE VALTYPE(FechaX)='D'
      FechaV:=VAL(DTOS(FechaX))
   OTHERWISE
      FechaV:=0
ENDCASE

RETURN(FechaV)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : F2ANUALMES
* COMENTARIO: Devuelve una cadena 6 digitos
*             los 4 primeros digitos son el ao
*             y los 2 restantes son el mes
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC F2ANUALMES(xFecha)

LOCAL sFecha

DO CASE
   CASE VALTYPE(xFecha)='C'
      sFecha:=LEFT(CTOS(xFecha),6)
   CASE VALTYPE(xFecha)='D'
      sFecha:=LEFT(DTOS(xFecha),6)
   OTHERWISE
      sFecha:=''
ENDCASE

RETURN(sFecha)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : SELLOFECHA
* COMENTARIO: Devuelve un string de 17 caracteres con el stamp actual del SERVIDOR.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC SELLOFECHA

LOCAL cSello := CTOS(DTOC(DATE()))+STRTRAN(TIME(),':')

RETURN(cSello)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : SELLO2DATE
* COMENTARIO: Devuelve la fecha contenida en el sello.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC SELLO2DATE( cSello )

LOCAL cFecha := STOC(LEFT(cSello,8))

RETURN(cFecha)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : SELLO2DATE
* COMENTARIO: Devuelve la fecha contenida en el sello.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC SELLO2TIME( cSello )

LOCAL cHora := SUBSTR(cSello,9,2) + ':' + SUBSTR(cSello,11,2) + ':' + SUBSTR(cSello,13,2)

RETURN(cHora)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : SELLOLOCAL
* COMENTARIO: Devuelve un string de 17 caracteres con el stamp local.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC SELLOLOCAL

LOCAL cSelloLocal := DTOS(HOY)+STRTRAN(TIME(),':')

RETURN( cSelloLocal )


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : SELLODATO
* COMENTARIO:
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC SELLODATO( cSello )

LOCAL cDato := SELLODATE( cSello )+' '+SELLOTIME( cSello )

RETURN(cDato)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : SELLODATE
* COMENTARIO:
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC SELLODATE( cSello )

LOCAL cFecha := STOC( LEFT(cSello,8) )

RETURN(cFecha)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : SELLOTIME
* COMENTARIO:
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC SELLOTIME( cSello , nLong )

LOCAL cHora

   IF nLong = 5
      cHora := SUBSTR(cSello,9,2) + ':' + SUBSTR(cSello,11,2)
   ELSE
      cHora := SUBSTR(cSello,9,2) + ':' + SUBSTR(cSello,11,2) + ':' + SUBSTR(cSello,13,2)
   ENDIF

RETURN(cHora)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : FECHASELLO
* COMENTARIO: Devuelve una cadena 14 digitos
*             Ao+Mes+Dia+Hora
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC FECHASELLO
PARA cFecha,cHora

LOCAL dFecha := CTOD(cFecha)
LOCAL sFecha := DTOS(dFecha)+LEFT(cHora,2)+SUBSTR(cHora,4,2)+RIGHT(cHora,2)

RETURN(sFecha)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : VALSTR
* COMENTARIO: Convertir un nmero a una cadena sin espacios
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC VALSTR(Number)

LOCAL STRNUM := ALLTRIM(STR(Number))

RETURN(STRNUM)


* ------------------------------------------------------------------------
* ------------------------------------------------------------------------
* FUNCION   : VALSTRPAD
* COMENTARIO: Convertir un nmero a una cadena con espacios de relleno
*             a la derecha.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC VALSTRPAD(Valor,Espacio)

LOCAL SubValor1:=ALLTRIM(STR(Valor))
LOCAL SubValor2

IF LEN(SubValor1)<=Espacio
   SubValor2:=PADL(SubValor1,Espacio)
ELSE
   SubValor2:=LEFT(SubValor1,Espacio)
ENDIF

RETURN(SubValor2)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : STRVAL
* COMENTARIO: Convertir una cadena a un nmero
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC STRVAL(Cadena)
LOCAL CNum:=''
LOCAL c , dig

FOR c=1 TO LEN(Cadena)
   dig=SUBSTR(Cadena,c,1)
   IF dig $ '-0123456789.'
      CNum+=dig
   ENDIF
NEXT

RETURN(VAL(CNum))


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : NUMPURO
* COMENTARIO: Saca de una cadena todo lo que no sea nmeros.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC STRNUMPURO(Cadena)

LOCAL CNum:=''
LOCAL c
LOCAL dig

   FOR c=1 TO LEN(Cadena)
      dig=SUBSTR(Cadena,c,1)
      IF dig $ '0123456789'
         CNum+=dig
      ENDIF
   NEXT

RETURN(CNum)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : STRTODOC
* COMENTARIO: Transforma una cadena a un numero de documento tipo '001-12345678'
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC STRTODOC( Cadena )

LOCAL cDoc := ''
LOCAL c , dig , nGui , cSer , cNum

   IF AT('-',Cadena) = 0
      DO CASE
         CASE LEFT(Cadena,2) = '00'
            Cadena := LEFT(Cadena,3)+'-'+RIGHT(Cadena,LEN(Cadena)-3)
         CASE LEFT(Cadena,1) = '0'
            Cadena := LEFT(Cadena,2)+'-'+RIGHT(Cadena,LEN(Cadena)-2)
         OTHERWISE
            Cadena := LEFT(Cadena,1)+'-'+RIGHT(Cadena,LEN(Cadena)-1)
      ENDCASE
   ENDIF

   FOR c=1 TO LEN(Cadena)
      dig=SUBSTR(Cadena,c,1)
      IF dig $ '0123456789-'
         cDoc := cDoc + dig
      ENDIF
   NEXT

   nGui := AT('-',cDoc)
   cSer := STRZERO( VAL( LEFT( cDoc , nGui-1 ) )          , 3 )
   cNum := STRZERO( VAL( RIGHT( cDoc , LEN(cDoc)-nGui ) ) , 8 )
   cDoc := cSer+'-'+cNum

RETURN(cDoc)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : ESCODIGO
* COMENTARIO: Verifica si el argumento es un cdigo.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC ESCODIGO(cCadena)

LOCAL lSiEs := .F.
LOCAL nNums := 0

cCadena := ALLTRIM(cCadena)
nLetras := LEN(cCadena)

FOR nLet = 1 TO nLetras
   IF SUBSTR(cCadena,nLet,1) $ '0123456789'
      nNums++
   ENDIF
NEXT

IF nNums = nLetras
   lSiEs := .T.
ENDIF

RETURN(lSiEs)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : STRR
* COMENTARIO: Convertir un nmero a una cadena y rellenar c/espacios
*             a la derecha.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC STRR(Number,Spaces)

LOCAL STRNUM:=PADR(ALLTRIM(STR(Number)),Spaces)

RETURN(STRNUM)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : STRCOMA
* COMENTARIO: Convertir un nmero a una cadena con comas.
*             Ejem.: 1123456.78 se convierte a '1'123,456.78'
* SINTAXIS  : Numero=STRCOMA(<VarNum>)
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC STRCOMA(Nmr,LnE,LnD)

LOCAL SNum , Ent , Dec , Coma , LnI , Num , tri

   Nmr:=IF(VALTYPE(Nmr)<>'N',VAL(Nmr),Nmr)
   LnE:=IF(LnE=NIL,13,LnE)
   LnD:=IF(LnD=NIL,2,LnD)
   SNum:=ALLTRIM(STR(Nmr,LnE,LnD))
   Ent:=IF(LnD>0,LEFT(SNum,LEN(SNum)-(LnD+1)),SNum)
   Dec:=IF(LnD>0,RIGHT(SNum,LnD+1),'')
   Coma:=','
   LnI:=LEN(Ent)-3
   Tpe:=IF(Nmr<0,2,1)

   FOR tri=LnI TO Tpe STEP -3
      Ent:=LEFT(Ent,tri)+Coma+RIGHT(Ent,LEN(Ent)-tri)
      Coma:=CHR(39)
   NEXT
   Num:=PADL(Ent,LnE-(LnD+1))+Dec

RETURN(Num)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : STR2DOC
* COMENTARIO: Convertir una cadena a nmero de DOCUMENTO para busqueda.
*             Ejem.: '3-6850' se convierte a '003-00006850'
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC STR2DOC(cString)

LOCAL cDocNum
LOCAL nGuion
LOCAL nLargo

   cString := ALLTRIM(cString)
   nGuion := AT('-',cString)
   nLargo := LEN(cString)
   IF nGuion > 0 .AND. nLargo > 3
      cIzq := LEFT( cString , nGuion-1 )
      cDer := RIGHT( cString , nLargo-nGuion )
      cDocNum := STRZERO(VAL(cIzq),3)+'-'+STRZERO(VAL(cDer),8)
   ENDIF

RETURN(cDocNum)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : NUL2SPC
* COMENTARIO: Convierte un valor nulo a un espacio.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC NUL2SPC(xVar)

LOCAL cVar := xVar

   IF VALTYPE(xVar)='U'
      cVar := ' '
   ENDIF
   IF VALTYPE(xVar)='C'
      cVar := ALLTRIM(cVar)
   ENDIF

RETURN(cVar)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : NUL2ZERO
* COMENTARIO: Convierte un valor nulo a un valor cero.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC NUL2ZERO(xVar)

LOCAL nVar := xVar

   IF VALTYPE(xVar)='U'
      nVar := 0
   ENDIF

RETURN(nVar)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION    : LOTEFIX
* COMENTARIO :
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC LOTEFIX( cLote )

LOCAL cLoteNuevo := ''
LOCAL cChar , nChar

   cLote := ALLTRIM( UPPER(cLote) )

   FOR nChar = 1 TO LEN( cLote )
      cChar := SUBSTR( cLote , nChar , 1 )
      IF cChar $ 'ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890'
         cLoteNuevo := cLoteNuevo + cChar
      ENDIF
   NEXT

RETURN( cLoteNuevo )


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION    : LOTEIGUAL
* COMENTARIO :
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC LOTEIGUAL( cLote1,cLote2 )

LOCAL lEsIgual := .F.

   cLote1 := ALLTRIM(cLote1)
   cLote1 := STRTRAN( cLote1 , "O" , "0" )
   cLote1 := STRTRAN( cLote1 , "I" , "1" )

   cLote2 := ALLTRIM(cLote2)
   cLote2 := STRTRAN( cLote2 , "O" , "0" )
   cLote2 := STRTRAN( cLote2 , "I" , "1" )

   IF cLote1 == cLote2
      lEsIgual := .T.
   ENDIF

RETURN( lEsIgual )


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : ASUM
* COMENTARIO: Devuelve la suma de un array unidimensional.
* SINTAXIS  : ASUM(aArray)
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC ASUM(aArray)

LOCAL TotalSuma:=0

AEVAL(aArray,{|nElem| TotalSuma+=nElem})

RETURN(TotalSuma)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : ALONGEST
* COMENTARIO: Devuelve la longitud ms larga de un array.
* SINTAXIS  : ALONGEST(aArray)
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC ALONGEST(aArray)

LOCAL nLongs := 0
LOCAL nMayor := 0

   FOR nArr = 1 TO LEN(aArray)
      IF LEN(aArray[nArr]) > nLongs
         nLongs := LEN(aArray[nArr])
         nMayor := nArr
      ENDIF
   NEXT

RETURN(nMayor)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : SUMAPORC
* COMENTARIO: Le suma a la cifra el porcentaje pasado.
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC SUMAPORC(Cifra,Porcentaje)

LOCAL Resulta:=Cifra*(1+(Porcentaje/100))

RETURN(Resulta)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : RESTPORC
* COMENTARIO: Le resta a la cifra el porcentaje pasado.
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC RESTAPORC(Cifra,Porcentaje)

LOCAL Resulta := ROUND( Cifra*(1-(Porcentaje/100)) , 2 )

RETURN(Resulta)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : SINIGV
* COMENTARIO: Resta el IGV a la cifra pasada como parametro
*             NOTA: DEBE EXISTIR LA VARIABLE PUBLICA SYS_IGV.
* SINTAXIS  : Nuevo=SINIGV(20.45,.T.) --> "
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC SINIGV(nCifra,lIgv)

LOCAL nResulta

IF lIgv = NIL
   lIgv := .T.
ELSE
   DO CASE
      CASE VALTYPE(lIgv) = 'C'
         IF lIgv = 'N'
            lIgv := .F.
         ELSE
            lIgv := .T.
         ENDIF
      CASE VALTYPE(lIgv) = 'N'
         IF lIgv > 0
            lIgv := .T.
         ELSE
            lIgv := .F.
         ENDIF
   ENDCASE
ENDIF

IF lIgv
   nResulta := nCifra/(1+(SYS_IGV/100))
ELSE
   nResulta := nCifra
ENDIF

RETURN(nResulta)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : SUBIGV
* COMENTARIO: Devuelve el subtotal IGV de nPrecio
* SINTAXIS  :
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC SUBIGV(nPrecio,nIgv)

LOCAL nNeto
LOCAL nSubIgv

   IF nIgv = NIL
      nIgv := SYS_IGV
   ENDIF

   IF nIgv > 0
      nSubIgv := nPrecio * (nIgv/100)
   ELSE
      nSubIgv := 0
   ENDIF

RETURN(nSubIgv)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : CONIGV
* COMENTARIO: Devuelve el subtotal + IGV
* SINTAXIS  :
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC CONIGV(nSub,nIgv)

LOCAL nSumado

   IF nIgv = NIL
      nSumado := nSub * (1+(SYS_IGV/100))
   ELSE
      IF nIgv > 0
         nSumado := nSub * (1+(nIgv/100))
      ELSE
         nSumado := nSub
      ENDIF
   ENDIF

RETURN(nSumado)


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : PRECIAR
* COMENTARIO: Devuelve el precio para una tabla.
* SINTAXIS  :
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC PRECIAR(nCosto,cTabla)

LOCAL nTabla  := ASCAN( SYS_TABLS , cTabla )
LOCAL nPorc   := 0
LOCAL nPrecio := 0

   IF nTabla > 0
      nPorc   := SYS_UTILS[nTabla]
      IF nPorc > 0
         nPrecio := nCosto * (1+(nPorc/100))
      ENDIF
   ENDIF

RETURN( nPrecio )


*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*
* FUNCION   : SUGERIDO
* COMENTARIO: Calcula el precio sugerido para el preciado por NETO.
* SINTAXIS  :
*>----------------------------------------------------------------------<*
*>----------------------------------------------------------------------<*

FUNC SUGERIDO(xneto,xutil)

LOCAL PrecioSug

PrecioSug := xneto+(xneto*(SYS_IGV/100))
PrecioSug := PrecioSug+(PrecioSug*(xutil/100))

RETURN(PrecioSug)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : OBTENIDO
* COMENTARIO: Devuelve el porcentaje de descuento que se obtuvo
*             al comprar el producto.
* SINTAXIS  : Descuento=OBTENIDO(Costo_Neto,Costo_Real)
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC OBTENIDO(Neto,Real)

LOCAL Descto := Neto-Real
LOCAL Pond   := ROUND((Descto*100)/Neto,2)

IF Pond<0 .OR. Real=0
   Pond := 0
ENDIF

RETURN(Pond)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : UTILIDAD
* COMENTARIO: Devuelve el porcentaje de utilidad obtenida (PRECIO - COSTO)
* SINTAXIS  : Descuento=OBTENIDO(Costo_Neto,Costo_Real)
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC UTILIDAD(CostoReal,PrecioVent,nDec)

LOCAL Ganancia
LOCAL Porcenta := 0

IF nDec = NIL
   nDec := 2
ENDIF

IF CostoReal > 0 .AND. PrecioVent > 0
   IF PrecioVent>CostoReal
      Ganancia:=PrecioVent-CostoReal
      Porcenta:=ROUND((Ganancia*100)/CostoReal,nDec)
   ELSE
      Ganancia:=CostoReal-PrecioVent
      Porcenta:=ROUND((Ganancia*100)/PrecioVent,nDec)
   ENDIF
ENDIF

RETURN(Porcenta)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : DESCONTADO
* COMENTARIO: Devuelve el porcentaje de descuento que se da al cliente
* SINTAXIS  : Descuento=DESCONTADO(nLista,nPrecio)
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC DESCUENTO(nLista,nPrecio)

LOCAL nDescto := nLista-nPrecio
LOCAL nPorcen := (nDescto*100)/nLista

RETURN(nPorcen)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : DESCUENTOTOTAL
* COMENTARIO: Suma los descuentos y obtiene el descuento total
* SINTAXIS  : DescuentoTotal( aDescuentos )
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC DESCUENTOTOTAL(aDctos)

LOCAL nDctoT := 100
LOCAL nDct

   FOR nDct = 1 TO LEN( aDctos )
      IF aDctos[nDct] > 0
         nDctoT := nDctoT * ( 1-(aDctos[nDct]/100) )
      ENDIF
   NEXT
   nDctoT := nDctoT - 100
   nDctoT := nDctoT - (nDctoT*2)

RETURN( nDctoT )

*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : PROMEDIO
* COMENTARIO: Devuelve el costo promedio.
* SINTAXIS  :
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC PROMEDIO(nUnit1,nUnid1,nUnit2,nUnid2)

LOCAL nPromedio := ( ( nUnit1*nUnid1 ) + ( nUnit2*nUnid2) ) / (nUnid1+nUnid2)

RETURN( nPromedio )


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : ESPAR
* COMENTARIO: DEVUELVE UN LOGICO SI LA Cifra es PAR
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC ESPAR(Cifra)

LOCAL SiEsPar:=.F.

IF Cifra=INT(Cifra/2)
   SiEsPar:=.T.
ENDIF

RETURN(SiEsPar)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : INTPLUS
* COMENTARIO: REDONDEA UN DECIMAL A UN NUMERO ENTERO SUPERIOR.
*             Si nValor es entero lo devuelve sin cambios.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC INTPLUS(nDecimal)

LOCAL nEntero

IF nDecimal=INT(nDecimal)
   nEntero=nDecimal
ELSE
   nEntero=INT(nDecimal)+1
ENDIF

RETURN(nEntero)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : CMTOFC
* COMENTARIO: CALCULA LA ALTURA Y ANCHO DEL PAPEL EN FILAS Y COLUMNAS.
*             Altura y Ancho deben ser en centimetros.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC CMTOFC(Altura,Ancho)

LOCAL Size:=ARRAY(4)

Size[1]:=INT(Altura/0.425)   && Filas disponibles en normal.
Size[2]:=INT(Altura/0.425)   && Filas disponibles en menuda.
Size[3]:=INT(Ancho/0.26)     && Columnas disponibles en normal.
Size[4]:=INT(Ancho/0.15)     && Columnas disponibles en menuda.

RETURN(Size)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : CMTOIN
* COMENTARIO: TRANSFORMA MEDIDA EN CM A PULGADAS.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC CMTOIN(Cm)

LOCAL In:=Cm/2.495

RETURN(In)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC TIPOBUSCA(cCadena)

LOCAL QueEs  := ''
LOCAL nCount := 0

   cCadena := RTRIM(cCadena)
   IF LEN(cCadena) >= 5
      FOR nCad=1 TO LEN(cCadena)
         IF SUBSTR(cCadena,nCad,1) $ '0123456789'
            nCount++
         ENDIF
      NEXT
   ENDIF
   DO CASE
      CASE LEN(cCadena) = nCount .AND. nCount = 5
         QueEs := 'codigo'
      CASE LEN(cCadena) = nCount .AND. nCount > 5
         QueEs := 'barra'
      OTHERWISE
         QueEs := 'nombre'
   ENDCASE

RETURN( QueEs )


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : GETSIZE
* COMENTARIO: DEVUELVE LA LONGITUD DEL ELEMENTO MAS LARGO DE UNA ARRAY.
*             Lo uso en VISUALES.PRG
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC GETSIZE(aOpcion)

LOCAL talla:=0

ASCAN(aOpcion,{|str| talla:=MAX(talla,LEN(str))})

RETURN(talla)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : DELALL
* COMENTARIO: FUNCION PARA BORRAR ARCHIVOS USANDO LOS CARACTERES COMODIN.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC DELALL(Ruta,Archi)

LOCAL Ttl := ADIR(Ruta+Archi)
LOCAL FtD

IF Ttl>0
   FtD:=ARRAY(Ttl)
   ADIR(Ruta+Archi,FtD)
   FOR d=1 TO Ttl
      FERASE(Ruta+FtD[d])
   NEXT
ENDIF

RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : ISDIR
* COMENTARIO: VERIFICAR EXISTENCIA DE UN DIRECTORIO.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC ISDIR(Directorio)

LOCAL aLista
LOCAL nDir
LOCAL nRuta
LOCAL nPos
LOCAL Existe := .F.
LOCAL Ruta
LOCAL Carpeta

IF AT('\',Directorio) > 0
   FOR nRuta=LEN(Directorio) TO 1 STEP -1
      IF SUBSTR(Directorio,nRuta,1) = '\'
         Ruta    := LEFT(Directorio,nRuta)
         Carpeta := RIGHT(Directorio,nRuta+1)
      ENDIF
   NEXT
ELSE
   Ruta := Directorio
ENDIF

aLista := DIRECTORY( Ruta+'*' , 'D' )

FOR nDir = 1 TO LEN(aLista)
   IF aLista[nDir,1] = Carpeta
      Existe := .T.
   ENDIF
NEXT

RETURN( Existe )


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : TablaVacia
* COMENTARIO: Revisa la base de datos actual para ver si esta vacia.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC TablaVacia(cTabla)

LOCAL xOldSele := SELECT()
LOCAL nOldRegi := 0
LOCAL NoHay    := .F.

   SELE &cTabla
   nOldRegi := RECNO()
   COUNT TO nRegistros FOR .NOT. DELETED()
   IF nRegistros = 0
      NoHay := .T.
   ENDIF
   DBGOTO( nOldREgi )
   SELE &xOldSele

RETURN(NoHay)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : NUM2LET
* COMENTARIO: TRANSFORMAR UN NUMERO A LETRAS.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC NUM2LET(CCantidad,cMoneda)

LOCAL NToL[46, 1]

NToL[ 1, 1] := "Un "
NToL[ 2, 1] := "Dos "
NToL[ 3, 1] := "Tres "
NToL[ 4, 1] := "Cuatro "
NToL[ 5, 1] := "Cinco "
NToL[ 6, 1] := "Seis "
NToL[ 7, 1] := "Siete "
NToL[ 8, 1] := "Ocho "
NToL[ 9, 1] := "Nueve "
NToL[10, 1] := "Diez "
NToL[11, 1] := "Once "
NToL[12, 1] := "Doce "
NToL[13, 1] := "Trece "
NToL[14, 1] := "Catorce "
NToL[15, 1] := "Quince "
NToL[16, 1] := "Dieciseis "
NToL[17, 1] := "Diecisiete "
NToL[18, 1] := "Dieciocho "
NToL[19, 1] := "Diecinueve "
NToL[20, 1] := "Veinte "
NToL[21, 1] := "Veintiun "
NToL[22, 1] := "Veintidos "
NToL[23, 1] := "Veintitres "
NToL[24, 1] := "Veinticuatro "
NToL[25, 1] := "Veinticinco "
NToL[26, 1] := "Veintiseis "
NToL[27, 1] := "Veintisiete "
NToL[28, 1] := "Veintiocho "
NToL[29, 1] := "Veintinueve "
NToL[30, 1] := "Treinta "
NToL[31, 1] := "Cuarenta "
NToL[32, 1] := "Cincuenta "
NToL[33, 1] := "Sesenta "
NToL[34, 1] := "Setenta "
NToL[35, 1] := "Ochenta "
NToL[36, 1] := "Noventa "
NToL[37, 1] := "Cien"
NToL[38, 1] := "Doscientos "
NToL[39, 1] := "Trecientos "
NToL[40, 1] := "Cuatrocientos "
NToL[41, 1] := "Quinientos "
NToL[42, 1] := "Seiscientos "
NToL[43, 1] := "Setecientos "
NToL[44, 1] := "Ochocientos "
NToL[45, 1] := "Novecientos "
NToL[46, 1] := "Mil "

aRemates0 := {'Uno','Dos','Tres','Cuatro','Cinco','Seis','Siete','Ocho','Nueve','Diez','Once','Doce','Trece','Catorce','Quince','Dieciseis','Diecisite','Dieciocho','Diecinueve','Veinte','Veintiuno','Veintidos','Veintitres','Veinticuatro','Veinticinco','Ventiseis','Veintisiete','Veintiocho','Veintinueve','Treinta'}
aRemates1 := {'Dieci','Veinti','Treinti','Cuarenti','Cincuenti','Sesenti','Setenti','Ochenti','Noventi'}
aRemates2 := {'uno','dos','tres','cuatro','cinco','seis','siete','ocho','nueve'}
aRemates3 := {'Diez','Veinte','Treinta','Cuarenta','Cincuenta','Sesenta','Setenta','Ochenta','Noventa'}

*****Millones*******

CCantL1    = Substr(Transform(CCantidad, "9999999.99"), 1, 7)
CCantL2    = Substr(CCantL1, 1, 1)

CCantidadL = IF(Val(CCantL2) > 0, NToL[Val(CCantL2), 1] +;
             IF(Val(CCantL2) > 1, "Millones ", "Millon "), "")

*****Cientos de miles*********

CCantL2    = Substr(CCantL1, 2, 1)
CCantL3    = Substr(CCantL1, 3, 2)

CCantidadL = CCantidadL + IF(Val(CCantL2) > 0, IF(Val(CCantL2) > 1,;
             NToL[(36 + Val(CCantL2)), 1], NToL[(36 +;
             Val(CCantL2)), 1] + IF(Val(CCantL3) > 0,;
             "to ", " ")) + IF(Val(CCantL3) = 0,;
             NToL[46, 1], ""), "")

*****Decenas de miles*********

CCantL2    = Substr(CCantL1, 3, 2)
CCantL3    = Substr(CCantL1, 3, 1)
CCantL4    = Substr(CCantL1, 4, 1)
CCantL5    = Substr(CCantL1, 2, 1)

CCantidadL = CCantidadL + IF(Val(CCantL2) < 30 .AND. Val(CCantL2) > 0,;
             IF(Val(CCantL2) > 1, NToL[Val(CCantL2), 1] +;
             NToL[46, 1], IF(Val(CCantL5) > 0,;
             NToL[Val(CCantL2), 1] + NToL[46, 1],;
             NToL[46, 1])), "")

CCantidadL = CCantidadL + IF(Val(CCantL2) > 29, NToL[(27 + ;
             Val(CCantL3)), 1] + IF(Val(CCantL4) > 0, "i" +;
             NToL[Val(CCantL4), 1] + NToL[46, 1], ""), "")

*****Cientos*********

CCantL2    = Substr(CCantL1, 5, 1)
CCantL3    = Substr(CCantL1, 6, 2)

CCantidadL = CCantidadL + IF(Val(CCantL2) > 0, IF(Val(CCantL2) > 1,;
             NToL[(36 + Val(CCantL2)), 1],;
             NToL[(36 + Val(CCantL2)), 1] +;
             IF(Val(CCantL3) > 0, "to ", " ")), "")

*****Decenas*********

CCantL2    = Substr(CCantL1, 6, 2)
CCantL3    = Substr(CCantL1, 6, 1)
CCantL4    = Substr(CCantL1, 7, 1)

IF VAL(CCantL4) > 0
   CCantidadL = CCantidadL + ;
             IF( Val(CCantL2) < 31 , aRemates0[VAL(cCantL2)]+" " , "" )
   CCantidadL = CCantidadL + ;
             IF( Val(CCantL2) > 30 , aRemates1[VAL(cCantL3)]+aRemates2[VAL(cCantL4)]+" " , "" )
ELSE
   IF VAL(CCantL3) > 0
      CCantidadL = CCantidadL + aRemates3[Val(CCantL3)]+" "
   ENDIF
ENDIF

IF cMoneda = 'S' .OR. cMoneda = NIL
   cMoneda1 := "Nuevo Sol"
   cMoneda2 := "Nuevos Soles"
ELSE
   cMoneda1 := "Dolar Americano"
   cMoneda2 := "Dlares Americanos"
ENDIF

CCantidadL = 'Son: ' + CCantidadL + "y " + Substr(Transform(CCantidad, "9999999.99"), -2) + "/100 " + IF(CCantidad > 1, cMoneda2, cMoneda1)

RETURN(CCantidadL)


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC FrecLogsADias(lLun,lMar,lMie,lJue,lVie,lSab)

LOCAL aFDias      := {'Dom','Lun','Mar','Mie','Jue','Vie','Sab'}
LOCAL aFLogs      := {.F.,lLun,lMar,lMie,lJue,lVie,lSab}
LOCAL cFrecuencia := ''

   IF lLun = .T. .AND. lMar = .T. .AND. lMie = .T. .AND. lJue = .T. .AND. lVie = .T. .AND. lSab = .T.
      cFrecuencia := 'DIARIO'
   ELSE
      FOR nFrec = 1 TO 7
         IF aFLogs[nFrec] = .T.
            cFrecuencia := cFrecuencia+aFDias[nFrec]+','
         ENDIF
      NEXT
   ENDIF

RETURN( cFrecuencia )


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : CalcularCostoReal
* COMENTARIO: Calcula y devuelve el costo real.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC CalcularCostoReal
PARA nPVF,nDctB,nDct1,nDct2,nDct3,nDct4

LOCAL nReal1 := 0
LOCAL nDctoT := 100

   // Calculo del COSTO REAL.
   nReal1 := nPVF * ( 1-(nDctB/100) )
   nReal1 := nReal1 * ( 1-(nDct1/100) )
   nReal1 := nReal1 * ( 1-(nDct2/100) )
   nReal1 := nReal1 * ( 1-(nDct3/100) )
   nReal1 := nReal1 * ( 1-(nDct4/100) )

   // Calculo del Dcto. Total
   nDctoT := ((nPVF-nReal1)*100) / nPVF

RETURN( nReal1 )


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC Cell2VAL( xCadena )

LOCAL nNumero := 0
LOCAL cTipo   := VALTYPE(xCadena)

   DO CASE
      CASE cTipo = 'C'
         nNumero := VAL( xCadena )
      CASE cTipo = 'N'
         nNumero := xCadena
      CASE cTipo = 'U'
         nNumero := 0
   ENDCASE

RETURN( nNumero )


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC Cell2CHR( xCadena )

LOCAL cCadena := ' '

   IF ! VALTYPE( xCadena ) = 'U'
      DO CASE
         CASE VALTYPE(xCadena) = 'C'
            cCadena := RTRIM(xCadena)
         CASE VALTYPE(xCadena) = 'N'
            cCadena := VALSTR(xCadena)
         CASE VALTYPE(xCadena) = 'D'
            cCadena := DTOC(xCadena)
      ENDCASE
   ENDIF

RETURN( cCadena )


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC TitulosMeses1( cFechaFin , nMeses )

LOCAL aLista := ARRAY( nMeses )
LOCAL nMes
LOCAL cFechaX := cFechaFin
LOCAL dFechaX := STOD( cFechaX )

   FOR nMes = nMeses TO 1 STEP -1
      aLista[ nMes ] := STRZERO( MONTH(dFechaX) , 2 ) + '_' + STR(YEAR(dFechaX),4)
      cFechaX := STR(YEAR(dFechaX),4)+STRZERO(MONTH(dFechaX),2)+'28'
      dFechaX := STOD( cFechaX ) - 29
   NEXT

RETURN( aLista )


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC TitulosMeses2( cFechaFin , nMeses )

LOCAL aLista := ARRAY( nMeses )
LOCAL nMes
LOCAL cFechaX := cFechaFin
LOCAL dFechaX := STOD( cFechaX )

   FOR nMes = 1 TO nMeses                 // nMeses TO 1 STEP -1
      aLista[ nMes ] := aMeses[ MONTH(dFechaX) ]+'_'+STR(YEAR(dFechaX),4)
      cFechaX := STR(YEAR(dFechaX),4)+STRZERO(MONTH(dFechaX),2)+'28'
      dFechaX := STOD( cFechaX ) - 29
   NEXT

RETURN( aLista )


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : RESTARHORAS
* COMENTARIO: RETORNA LA DIFERENCIA ENTRE LA HORA INICIAL Y LA FINAL
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC RESTARHORAS(cHoraIni,cHoraFin)

LOCAL nSecs := SECS(cHoraFin) - SECS(cHoraIni)
LOCAL nHras := INT( nSecs / 3600 )
LOCAL nSec2 := nSecs - (nHras * 3600)
LOCAL nMins := INT( nSec2 / 60 )
LOCAL nSec3 := nSec2 - (nMins * 60)
LOCAL cLaps := STRZERO(nHras,2)+':'+STRZERO(nMins,2)+':'+STRZERO(nSec3,2)

RETURN( cLaps )


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : SUMARHORAS
* COMENTARIO: SUMA LOS TIEMPOS
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC SUMARHORAS(aHoras)

LOCAL nSecs
LOCAL nHras
LOCAL nSec2
LOCAL nMins
LOCAL nSec3

   cAcum := aHoras[1]
   FOR nHra = 2 TO LEN(aHoras)

      nSecs := SECS(cAcum) + SECS(aHoras[nHra])

      nHras := INT( nSecs / 3600 )
      nSec2 := nSecs - (nHras * 3600)
      nMins := INT( nSec2 / 60 )
      nSec3 := nSec2 - (nMins * 60)
      cAcum := STRZERO(nHras,2)+':'+STRZERO(nMins,2)+':'+STRZERO(nSec3,2)

   NEXT

RETURN( cAcum )


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : ASCANMULTI
* COMENTARIO: SCAN DENTRO DE UNA MATRIZ MULTIPLE
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC ASCANMULTI( aMatriz , xBusqueda , nSub )

LOCAL nPosic := 0
LOCAL nScn

   FOR nScn = 1 TO LEN( aMatriz )
      IF aMatriz[nScn,nSub] = xBusqueda
         nPosic := nScn
         EXIT
      ENDIF
   NEXT

RETURN( nPosic )