*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* SISTEMA.......: INFOFARMA
* PROGRAMA......: LIBRARY.PRG
* AUTOR.........: EDUARDO V. FLORES RIVAS
* FECHA.........: 19-04-94
* ACTUALIZADO...: 23-05-95
* COMENTARIOS...: LIBRERIA DE PROCEDURES Y FUNCIONES DEL ENTORNO VISUAL.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : QUEFECHA
* COMENTARIO: Devuelve una fecha elegida por el usuario.
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC QUEFECHA(cTitulo)

PRIVATE cQueFecha := ''

   DEFINE WINDOW Win_QueFecha ;
      AT 0 , 0 ;
      WIDTH 200 HEIGHT 100 ;
      TITLE cTitulo ;
      CHILD

   @  010 , 010 LABEL LblFecha ;
      VALUE 'Fecha:' ;
      WIDTH 60 ;
      HEIGHT 20 ;
      FONTCOLOR Color_Label2_Font ;
      BACKCOLOR Color_Label2_Back ;
      RIGHTALIGN

   @  010 , 080 DATEPICKER DatFecha ;
      WIDTH  90 ;
      HEIGHT 20

   @  040 , 010 BUTTON BtnAceptar ;
      CAPTION 'Aceptar' ;
      ACTION QueFechaAceptar() ;
      WIDTH  70 ;
      HEIGHT 20

   @  040 , 090 BUTTON BtnCancelar ;
      CAPTION 'Cancelar' ;
      ACTION QueFechaCancelar() ;
      WIDTH  70 ;
      HEIGHT 20

   END WINDOW

   CENTER WINDOW Win_QueFecha
   ACTIVATE WINDOW Win_QueFecha

RETURN( cQueFecha )


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC QueFechaAceptar

   cQueFecha := DTOC( Win_QueFecha.DatFecha.Value )
   Win_QueFecha.Release

RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC QueFechaCancelar

   cQueFecha := ''
   Win_QueFecha.Release

RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------
* FUNCION   : INPUTPASS
* COMENTARIO:
*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

FUNC INPUTPASS(cTitulo)

PRIVATE cQuePassW := ''

IF cTitulo = NIL
   cTitulo := 'Clave'
ENDIF

   DEFINE WINDOW Win_QuePassW ;
      AT 0 , 0 ;
      WIDTH 200 HEIGHT 100 ;
      TITLE cTitulo ;
      CHILD

   @  010 , 010 LABEL LblPassWord ;
      VALUE 'Clave:' ;
      WIDTH 60 ;
      HEIGHT 20 ;
      FONTCOLOR Color_Label2_Font ;
      BACKCOLOR Color_Label2_Back ;
      RIGHTALIGN

   @  010 , 080 TEXTBOX TxtPassWord ;
      WIDTH  90 ;
      HEIGHT 20 ;
      PASSWORD ;
      ON ENTER Win_QuePassW.BtnAceptar.SetFocus

   @  040 , 010 BUTTON BtnAceptar ;
      CAPTION 'Aceptar' ;
      ACTION QuePassWAceptar() ;
      WIDTH  70 ;
      HEIGHT 20

   @  040 , 090 BUTTON BtnCancelar ;
      CAPTION 'Cancelar' ;
      ACTION QuePassWCancelar() ;
      WIDTH  70 ;
      HEIGHT 20

   END WINDOW

   CENTER WINDOW Win_QuePassW
   ACTIVATE WINDOW Win_QuePassW

RETURN( cQuePassW )


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC QuePassWAceptar

   cQuePassW := ALLTRIM(Win_QuePassW.TxtPassWord.Value)
   Win_QuePassW.Release

RETURN


*-------------------------------------------------------------------------
*-------------------------------------------------------------------------

PROC QuePassWCancelar

   cQuePassW := ''
   Win_QuePassW.Release

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
* FUNCION   : GETAnualMesDELAL
* COMENTARIO: Devuelve una matriz con fecha inicio y fecha final
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

FUNC GetAnualMesDelAl(cTitulo)

PRIVATE aDatos   := {}
PRIVATE aMeses   := { 'Enero' , 'Febrero' , 'Marzo' , 'Abril' , 'Mayo' , 'Junio', 'Julio' , 'Agosto' , 'Setiembre' , 'Octubre' , 'Noviembre' , 'Diciembre' }
PRIVATE aAnuales := {}

IF cTitulo = NIL
   cTitulo := 'Ingresar meses'
ENDIF

FOR nAnual = 2006 TO YEAR(HOY)
   AADD( aAnuales , STR( nAnual , 4 ) )
NEXT

DEFINE WINDOW Win_QueFecha ;
   AT 0 , 0 ;
   WIDTH 300 HEIGHT 180 ;
   TITLE cTitulo ;
   MODAL ;
   FONT "Arial" SIZE 9

   @ 020 , 010 LABEL LblAnual ;
      WIDTH   240 ;
      HEIGHT  20 ;
      VALUE "Ingrese Rango de fechas" ;
      CENTERALIGN
//
//
//
   @ 050 , 010 LABEL LblMesInicial ;
      WIDTH   80 ;
      HEIGHT  20 ;
      VALUE "Desde:" ;
      CENTERALIGN

   @ 050 , 100 COMBOBOX CmbAnual1 ;
      ITEMS aAnuales ;
      WIDTH   80 ;
      VALUE LEN(aAnuales)

   @ 050 , 190 COMBOBOX CmbMesInicial ;
      ITEMS aMeses ;
      WIDTH   80 ;
      VALUE 1
//
//
//
   @ 080 , 010 LABEL LblMesFinal ;
      WIDTH   80 ;
      HEIGHT  20 ;
      VALUE "Hasta:" ;
      CENTERALIGN

   @ 080 , 100 COMBOBOX CmbAnual2 ;
      ITEMS aAnuales ;
      WIDTH   80 ;
      VALUE LEN(aAnuales)

   @ 080 , 190 COMBOBOX CmbMesFinal ;
      ITEMS aMeses ;
      WIDTH   80 ;
      VALUE 1
//
//
//
   @ 120 , 010 BUTTON ACEPTAR ;
      CAPTION '&Aceptar' ;
      ACTION AceptarFecha() ;
      WIDTH 90 HEIGHT 25

   @ 120 , 120 BUTTON CANCELAR ;
      CAPTION '&Cancelar' ;
      ACTION CancelarFecha() ;
      WIDTH 90 HEIGHT 25

END WINDOW

CENTER WINDOW Win_QueFecha
ACTIVATE WINDOW Win_QueFecha

RETURN( aDatos )


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC CancelarFecha

   aDatos := {}
   RELEASE WINDOW Win_QueFecha

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC AceptarFecha

LOCAL cFecha1 := aAnuales[Win_QueFecha.CmbAnual1.Value]+STRZERO(Win_QueFecha.CmbMesInicial.Value,2)
LOCAL cFecha2 := aAnuales[Win_QueFecha.CmbAnual2.Value]+STRZERO(Win_QueFecha.CmbMesFinal.Value,2)

   aDatos := { cFecha1 , cFecha2 }
   RELEASE WINDOW Win_QueFecha

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
* FUNCION   : GETFECHADELAL
* COMENTARIO: Devuelve una matriz con fecha inicio y fecha final
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

FUNC GetFechaDelAl(cTitulo)

PRIVATE aDatos   := {}

IF cTitulo = NIL
   cTitulo := 'Ingresar fechas'
ENDIF

DEFINE WINDOW Win_QueFecha ;
   AT 0 , 0 ;
   WIDTH 300 HEIGHT 180 ;
   TITLE cTitulo ;
   MODAL ;
   FONT "Arial" SIZE 9

   @ 020 , 010 LABEL LblAnual ;
      WIDTH   240 ;
      HEIGHT  20 ;
      VALUE "Ingrese Rango de fechas" ;
      CENTERALIGN
//
//
//
   @ 050 , 010 LABEL LblMesInicial ;
      WIDTH   80 ;
      HEIGHT  20 ;
      VALUE "Desde:" ;
      CENTERALIGN

   @ 050 , 100 DATEPICKER DatInicio ;
      WIDTH   90 ;
      VALUE DATE()
//
//
//
   @ 080 , 010 LABEL LblMesFinal ;
      WIDTH   80 ;
      HEIGHT  20 ;
      VALUE "Hasta:" ;
      CENTERALIGN

   @ 080 , 100 DATEPICKER DatFinal ;
      WIDTH   90 ;
      VALUE DATE()

//
//
//
   @ 120 , 010 BUTTON ACEPTAR ;
      CAPTION '&Aceptar' ;
      ACTION FechaDelAlAceptar() ;
      WIDTH 90 HEIGHT 25

   @ 120 , 120 BUTTON CANCELAR ;
      CAPTION '&Cancelar' ;
      ACTION FechaDelAlCancelar() ;
      WIDTH 90 HEIGHT 25

END WINDOW

CENTER WINDOW Win_QueFecha
ACTIVATE WINDOW Win_QueFecha

RETURN( aDatos )


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC FechaDelAlCancelar

   aDatos := {}
   RELEASE WINDOW Win_QueFecha

RETURN


*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*
*------------------------------------------------------------------------------*

PROC FechaDelAlAceptar

LOCAL cFecha1 := DTOC(Win_QueFecha.DatInicio.Value)
LOCAL cFecha2 := DTOC(Win_QueFecha.DatFinal.Value)

   aDatos := { cFecha1 , cFecha2 }
   RELEASE WINDOW Win_QueFecha

RETURN